package com.gct.edge.actuator.entity;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.gct.common.util.DateTimeUtil;
import com.gct.edge.actuator.exception.ObjectParseException;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.lang.reflect.InvocationTargetException;
import java.time.LocalDateTime;

/**
 * dec: DiagnoseResultRealTime
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/10/24 下午2:16
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "DeepLearnTestServer对象", description = "")
@TableName("diagnose_result_real_time")
public class DiagnoseResultRealTime extends Model<DiagnoseResultRealTime> implements FileParseObject {

    private static final long serialVersionUID = 1L;
    /**
     * shard key
     */
    @ApiModelProperty(value = "分库分表所需key")
    private String moduleKey;

    @ApiModelProperty(value = "实时时间")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime proTime;

    @ApiModelProperty(value = "唯一uuid")
    @TableId(type = IdType.ASSIGN_UUID)
    private String id;

    @ApiModelProperty(value = "一次诊断结果")
    private String result1;

    @ApiModelProperty(value = "二次诊断结果")
    private String result2;

    @ApiModelProperty(value = "井名称")
    private String wellId;

    @ApiModelProperty(value = "示功图")
    private String workDiagram;

    @ApiModelProperty(value = "过程参数")
    private String processParam;

    @ApiModelProperty(value = "标记")
    private String remark;

    @ApiModelProperty(value = "创建时间")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime createTime;

    @ApiModelProperty(value = "用户确认时间")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime userConfirmTime;

    @ApiModelProperty(value = "用户确认内容")
    private String userConfirmContent;

    @ApiModelProperty(value = "是否是问题")
    private String isProblem;

    @ApiModelProperty(value = "是否符合预期")
    private Integer isExpected;

    @Override
    protected Serializable pkVal() {
        return null;
    }

    @Override
    public void initFromTxtRow(String[] objFields) throws ObjectParseException, NoSuchMethodException, InvocationTargetException, IllegalAccessException, InstantiationException {
        //记录txt文件中的数据对应的类名及类型 与单列数据split后的含义一致
        final String[] colName = {
                "id", "result1", "result2", "wellId", "workDiagram", "processParam",
                "remark", "createTime", "userConfirmTime", "userConfirmContent", "isProblem", "isExpected"
        };
        final String[] colType = {
                "String", "String", "String", "String", "String", "String",
                "String", "LocalDateTime", "LocalDateTime", "String", "String", "Integer",
        };
        initFromTxtRow(objFields,colName,colType);
        this.setProTime(DateTimeUtil.formatDateTime(JSONObject.parseObject(this.getProcessParam()).getString("sgt_recivetime")));
    }
}
