package com.gct.edge.actuator.util;

import com.gct.edge.actuator.entity.DiagnoseResultRealTime;
import com.gct.edge.actuator.entity.FileParseObject;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.multipart.MultipartFile;

import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * dec: DataTranslator
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/10/24 下午2:54
 */
@Slf4j
public class DataTranslator {

    public static<T extends FileParseObject> List<T> transFileToFileParseObject(InputStream file, Class<T> clz) {
        List<T> list = new ArrayList<>();
        try(BufferedReader reader = new BufferedReader(new InputStreamReader(file))){
            String line;
            while((line=reader.readLine())!=null){
                String[] objFields = Arrays.stream(line.split(FileParseObject.SPLIT_STR)).map(m -> {
                    if (m.equals("null")) return null;
                    return m;
                }).toArray(String[]::new);
                T instance = clz.newInstance();
                instance.initFromTxtRow(objFields);
                list.add(instance);
            }
        }catch (Exception e){
            log.error("parse failed, cause by {}",e.getMessage());
        }
        return list;
    }
}
