package com.gct.edge.actuator.util;

import lombok.extern.slf4j.Slf4j;
import org.apache.sshd.client.SshClient;
import org.apache.sshd.client.scp.ScpClient;
import org.apache.sshd.client.scp.SimpleScpClient;
import org.apache.sshd.client.scp.SimpleScpClientImpl;
import org.apache.tomcat.jni.Directory;
import org.springframework.beans.factory.annotation.Value;

import java.io.File;
import java.io.IOException;
import java.util.UUID;

/**
 * @author xusirui 2021/11/17
 */
@Slf4j
public class SshUtil {


    /**
     * @param username
     * @param password
     * @param host
     * @param port
     * @param remoteFile 绝对路径
     * @param localFile  绝对路径
     * @return
     * @throws IOException
     */
    public static File getRemoteFile(String username, String password, String host, Integer port, String remoteFile, String localFile) throws IOException {
        if (port == null) port = 22;
        try (SshClient client = SshClient.setUpDefaultClient()) {
            try (SimpleScpClient scpClient = new SimpleScpClientImpl(SshClient.wrapAsSimpleClient(client))) {
                client.start();
                ScpClient scp = scpClient.scpLogin(host, port, username, password);
                File file = new File(localFile);
                if (!file.getParentFile().exists()) file.getParentFile().mkdirs();
                scp.download(remoteFile, localFile);
                System.out.println("remoteFile = " + remoteFile);
                System.out.println("localFile = " + localFile);
                return new File(localFile);
            } catch (IOException e) {
                throw new IOException("download file by ssh connection failed,cause by " + e.getMessage());
            }
        } catch (IOException e) {
            throw new IOException("create ssh connection failed,cause by " + e.getMessage());
        }
    }
}
